<?php

/**
 * Implementation of hook_views_query_substitutions().
 */
function viewssub_views_query_substitutions($view) {
  return viewssub_get_custom_substitutions();
}

/**
 * Implementation of hook_views_handlers().
 */
function viewssub_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'viewssub') . '/handlers',
    ),
    'handlers' => array(
      'viewssub_handler_filter_in_operator' => array(
	'parent' => 'views_handler_filter_in_operator',
      ),
      'viewssub_handler_filter_many_to_one' => array(
	'parent' => 'views_handler_filter_many_to_one',
      ),
      'viewssub_handler_filter_term_node_tid' => array(
        'parent' => 'views_handler_filter_term_node_tid',
      ),
    ),
  );
}

/**
 * Implementation of hook_views_data_alter().
 */
function viewssub_views_data_alter(&$data) {
  $data['node']['viewssub_type'] = array(
    'title' => t('Type'),
    'help' => t('This provides the same functionality as the original <em>Type</em> handler, but uses a query substitution instead of a fixed value.'),
    'real field' => 'type',
    'filter' => array(
      'handler' => 'viewssub_handler_filter_in_operator',
    ),
  );
  $data['term_data']['viewssub_tid'] = array(
    'title' => t('Term ID'),
    'help' => t('This provides the same functionality as the original <em>Term ID</em> handler, but uses a query substitution instead of a fixed value.'),
    'real field' => 'tid',
    'filter' => array(
      'handler' => 'viewssub_handler_filter_in_operator',
    ),
  );
  $data['term_data']['viewssub_vid'] = array(
    'title' => t('Vocabulary'),
    'help' => t('This provides the same functionality as the original <em>Vocabulary</em> handler, but uses a query substitution instead of a fixed value.'),
    'real field' => 'vid',
    'filter' => array(
      'handler' => 'viewssub_handler_filter_in_operator',
    ),
  );
  $data['term_node']['viewssub_tid'] = array(
    'title' => t('Term'),
    'help' => t('This provides the same functionality as the original <em>Term</em> handler, but uses a query substitution instead of a fixed value.'),
    'real field' => 'tid',
    'filter' => array(
      'handler' => 'viewssub_handler_filter_term_node_tid',
      'hierarchy table' => 'term_hierarchy',
      'numeric' => TRUE,
      'skip base' => 'term_data',
      'allow empty' => TRUE,
    ),
  );
  $data['users_roles']['viewssub_rid'] = array(
    'title' => t('Roles'),
    'help' => t('This provides the same functionality as the original <em>Roles</em> handler, but uses a query substitution instead of a fixed value.'),
    'real field' => 'rid',
    'filter' => array(
      'handler' => 'viewssub_handler_filter_many_to_one',
    ),
  );
}
